## openjpeg2 2.3.1

=== CMakeLists.txt ===
# Main CMakeLists.txt to build the OpenJPEG project using CMake (www.cmake.org)
# Written by Mathieu Malaterre

# This CMake project will by default create a library called openjpeg
# But if you want to use this project within your own (CMake) project
# you will eventually like to prefix the library to avoid linking confusion
# For this purpose you can define a CMake var: OPENJPEG_NAMESPACE to whatever you like
# e.g.:
# set(OPENJPEG_NAMESPACE "GDCMOPENJPEG")
cmake_minimum_required(VERSION 2.8.2)

if(COMMAND CMAKE_POLICY)
  cmake_policy(SET CMP0003 NEW)
  if (NOT (${CMAKE_VERSION} VERSION_LESS 3.0))
    cmake_policy(SET CMP0042 NEW)
  endif()
endif()

if(NOT OPENJPEG_NAMESPACE)
  set(OPENJPEG_NAMESPACE "OPENJPEG")
  set(OPENJPEG_STANDALONE 1)
endif()
# In all cases:
#string(TOLOWER ${OPENJPEG_NAMESPACE} OPENJPEG_LIBRARY_NAME)
set(OPENJPEG_LIBRARY_NAME openjp2)

project(${OPENJPEG_NAMESPACE})

# Do full dependency headers.
include_regular_expression("^.*$")

#-----------------------------------------------------------------------------
# OPENJPEG version number, useful for packaging and doxygen doc:
set(OPENJPEG_VERSION_MAJOR 2)
set(OPENJPEG_VERSION_MINOR 3)
set(OPENJPEG_VERSION_BUILD 1)
set(OPENJPEG_VERSION
  "${OPENJPEG_VERSION_MAJOR}.${OPENJPEG_VERSION_MINOR}.${OPENJPEG_VERSION_BUILD}")
set(PACKAGE_VERSION
  "${OPENJPEG_VERSION_MAJOR}.${OPENJPEG_VERSION_MINOR}.${OPENJPEG_VERSION_BUILD}")

# Because autotools does not support X.Y notation for SOVERSION, we have to use
# two numbering, one for the openjpeg version and one for openjpeg soversion
# version | soversion
#   1.0   |  0
#   1.1   |  1
#   1.2   |  2
#   1.3   |  3
#   1.4   |  4
#   1.5   |  5
#   1.5.1 |  5
#   2.0   |  6
#   2.0.1 |  6
#   2.1   |  7
#   2.1.1 |  7
#   2.1.2 |  7
#   2.2.0 |  7
#   2.3.0 |  7
#   2.3.1 |  7
# above is the recommendation by the OPJ team. If you really need to override this default,
# you can specify your own OPENJPEG_SOVERSION at cmake configuration time:
# cmake -DOPENJPEG_SOVERSION:STRING=42 /path/to/openjpeg
if(NOT OPENJPEG_SOVERSION)
  set(OPENJPEG_SOVERSION 7)
endif(NOT OPENJPEG_SOVERSION)
set(OPENJPEG_LIBRARY_PROPERTIES
  VERSION   "${OPENJPEG_VERSION_MAJOR}.${OPENJPEG_VERSION_MINOR}.${OPENJPEG_VERSION_BUILD}"
  SOVERSION "${OPENJPEG_SOVERSION}"
)

# --------------------------------------------------------------------------
# Path to additional CMake modules
set(CMAKE_MODULE_PATH
    ${${OPENJPEG_NAMESPACE}_SOURCE_DIR}/cmake
    ${CMAKE_MODULE_PATH})

# --------------------------------------------------------------------------
# On Visual Studio 8 MS deprecated C. This removes all 1.276E1265 security
# warnings
if(WIN32)
  if(NOT BORLAND)
    if(NOT CYGWIN)
      if(NOT MINGW)
        if(NOT ITK_ENABLE_VISUAL_STUDIO_DEPRECATED_C_WARNINGS)
          add_definitions(
            -D_CRT_FAR_MAPPINGS_NO_DEPRECATE
            -D_CRT_IS_WCTYPE_NO_DEPRECATE
            -D_CRT_MANAGED_FP_NO_DEPRECATE
            -D_CRT_NONSTDC_NO_DEPRECATE
            -D_CRT_SECURE_NO_DEPRECATE
            -D_CRT_SECURE_NO_DEPRECATE_GLOBALS
            -D_CRT_SETERRORMODE_BEEP_SLEEP_NO_DEPRECATE
            -D_CRT_TIME_FUNCTIONS_NO_DEPRECATE
            -D_CRT_VCCLRIT_NO_DEPRECATE
            -D_SCL_SECURE_NO_DEPRECATE
            )
        endif()
      endif()
    endif()
  endif()
endif()


# --------------------------------------------------------------------------
# Install directories
# Build DOCUMENTATION (not in ALL target and only if Doxygen is found)
option(BUILD_DOC "Build the HTML documentation (with doxygen if available)." OFF)

string(TOLOWER ${PROJECT_NAME} projectname)
set(OPENJPEG_INSTALL_SUBDIR "${projectname}-${OPENJPEG_VERSION_MAJOR}.${OPENJPEG_VERSION_MINOR}")

if(NOT OPENJPEG_INSTALL_BIN_DIR)
  set(OPENJPEG_INSTALL_BIN_DIR "bin")
endif()

if(NOT OPENJPEG_INSTALL_LIB_DIR)
  set(OPENJPEG_INSTALL_LIB_DIR "lib")
endif()

if(NOT OPENJPEG_INSTALL_SHARE_DIR)
  set(OPENJPEG_INSTALL_SHARE_DIR "share")
endif()

if(NOT OPENJPEG_INSTALL_DATA_DIR)
  set(OPENJPEG_INSTALL_DATA_DIR "${OPENJPEG_INSTALL_SHARE_DIR}/${OPENJPEG_INSTALL_SUBDIR}")
endif()

if(NOT OPENJPEG_INSTALL_INCLUDE_DIR)
  set(OPENJPEG_INSTALL_INCLUDE_DIR "include/${OPENJPEG_INSTALL_SUBDIR}")
endif()

if(BUILD_DOC)
if(NOT OPENJPEG_INSTALL_MAN_DIR)
  set(OPENJPEG_INSTALL_MAN_DIR "share/man/")
endif()

if(NOT OPENJPEG_INSTALL_DOC_DIR)
  set(OPENJPEG_INSTALL_DOC_DIR "share/doc/${OPENJPEG_INSTALL_SUBDIR}")
endif()
endif()

if(NOT OPENJPEG_INSTALL_JNI_DIR)
  if(WIN32)
    set(OPENJPEG_INSTALL_JNI_DIR ${OPENJPEG_INSTALL_BIN_DIR})
  else()
    set(OPENJPEG_INSTALL_JNI_DIR ${OPENJPEG_INSTALL_LIB_DIR})
  endif()
endif()

if(NOT OPENJPEG_INSTALL_PACKAGE_DIR)
  # We could install *.cmake files in share/ however those files contains
  # hardcoded path to libraries on a multi-arch system (fedora/debian) those
  # path will be different (lib/i386-linux-gnu vs lib/x86_64-linux-gnu)
  set(OPENJPEG_INSTALL_PACKAGE_DIR "${OPENJPEG_INSTALL_LIB_DIR}/${OPENJPEG_INSTALL_SUBDIR}")
endif()

if (APPLE)
	list(APPEND OPENJPEG_LIBRARY_PROPERTIES INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/${OPENJPEG_INSTALL_LIB_DIR}")
	option(OPJ_USE_DSYMUTIL "Call dsymutil on binaries after build." OFF)
endif()

#-----------------------------------------------------------------------------
# Big endian test:
include (${CMAKE_ROOT}/Modules/TestBigEndian.cmake)
TEST_BIG_ENDIAN(OPJ_BIG_ENDIAN)

#-----------------------------------------------------------------------------
# Setup file for setting custom ctest vars
configure_file(
  ${${OPENJPEG_NAMESPACE}_SOURCE_DIR}/cmake/CTestCustom.cmake.in
  ${${OPENJPEG_NAMESPACE}_BINARY_DIR}/CTestCustom.cmake
  @ONLY
  )

#-----------------------------------------------------------------------------
# OpenJPEG build configuration options.
option(BUILD_SHARED_LIBS "Build OpenJPEG shared library and link executables against it." ON)
option(BUILD_STATIC_LIBS "Build OpenJPEG static library." ON)
set (EXECUTABLE_OUTPUT_PATH ${OPENJPEG_BINARY_DIR}/bin CACHE PATH "Single output directory for building all executables.")
set (LIBRARY_OUTPUT_PATH ${OPENJPEG_BINARY_DIR}/bin CACHE PATH "Single output directory for building all libraries.")
mark_as_advanced(LIBRARY_OUTPUT_PATH EXECUTABLE_OUTPUT_PATH)

#-----------------------------------------------------------------------------
# configure name mangling to allow multiple libraries to coexist
# peacefully
if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/openjpeg_mangle.h.in)
set(MANGLE_PREFIX ${OPENJPEG_LIBRARY_NAME})
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/openjpeg_mangle.h.in
               ${CMAKE_CURRENT_BINARY_DIR}/openjpeg_mangle.h
               @ONLY)
endif()

#-----------------------------------------------------------------------------
# Compiler specific flags:
if(CMAKE_COMPILER_IS_GNUCC)
  # For all builds, make sure openjpeg is std99 compliant:
  # set(CMAKE_C_FLAGS "-Wall -std=c99 ${CMAKE_C_FLAGS}") # FIXME: this setting prevented us from setting a coverage build.
  # Do not use ffast-math for all build, it would produce incorrect results, only set for release:
  set(OPENJPEG_LIBRARY_COMPILE_OPTIONS ${OPENJPEG_LIBRARY_COMPILE_OPTIONS} "$<$<CONFIG:Release>:-ffast-math>")
  set(OPENJP2_COMPILE_OPTIONS ${OPENJP2_COMPILE_OPTIONS} "$<$<CONFIG:Release>:-ffast-math>" -Wall -Wextra -Wconversion -Wunused-parameter -Wdeclaration-after-statement -Werror=declaration-after-statement)
endif()

#-----------------------------------------------------------------------------
# opj_config.h generation (1/2)

# Check if some include files are provided by the system
include(EnsureFileInclude)
# These files are mandatory
ensure_file_include("string.h"   HAVE_STRING_H YES)
ensure_file_include("memory.h"   HAVE_MEMORY_H YES)
ensure_file_include("stdlib.h"   HAVE_STDLIB_H YES)
ensure_file_include("stdio.h"    HAVE_STDIO_H  YES)
ensure_file_include("math.h"     HAVE_MATH_H   YES)
ensure_file_include("float.h"    HAVE_FLOAT_H  YES)
ensure_file_include("time.h"     HAVE_TIME_H   YES)
ensure_file_include("stdarg.h"   HAVE_STDARG_H YES)
ensure_file_include("ctype.h"    HAVE_CTYPE_H  YES)
ensure_file_include("assert.h"   HAVE_ASSERT_H YES)

# For the following files, we provide an alternative, they are not mandatory
ensure_file_include("stdint.h"   OPJ_HAVE_STDINT_H   NO)
ensure_file_include("inttypes.h" OPJ_HAVE_INTTYPES_H NO)

# why check this one ? for openjpip ?
include (${CMAKE_ROOT}/Modules/CheckIncludeFile.cmake)
CHECK_INCLUDE_FILE("strings.h"      HAVE_STRINGS_H)
CHECK_INCLUDE_FILE("sys/stat.h"     HAVE_SYS_STAT_H)
CHECK_INCLUDE_FILE("sys/types.h"    HAVE_SYS_TYPES_H)
CHECK_INCLUDE_FILE("unistd.h"       HAVE_UNISTD_H)

# Enable Large file support
include(TestLargeFiles)
OPJ_TEST_LARGE_FILES(OPJ_HAVE_LARGEFILES)

# Allocating Aligned Memory Blocks
include(CheckIncludeFiles)
check_include_files(malloc.h OPJ_HAVE_MALLOC_H)
include(CheckSymbolExists)
# _aligned_alloc https://msdn.microsoft.com/en-us/library/8z34s9c6.aspx
check_symbol_exists(_aligned_malloc malloc.h OPJ_HAVE__ALIGNED_MALLOC)
# posix_memalign (needs _POSIX_C_SOURCE >= 200112L on Linux)
set(CMAKE_REQUIRED_DEFINITIONS -D_POSIX_C_SOURCE=200112L)
check_symbol_exists(posix_memalign stdlib.h OPJ_HAVE_POSIX_MEMALIGN)
unset(CMAKE_REQUIRED_DEFINITIONS)
# memalign (obsolete)
check_symbol_exists(memalign malloc.h OPJ_HAVE_MEMALIGN)
#-----------------------------------------------------------------------------
# Build Library
if(BUILD_JPIP_SERVER)
  find_package(CURL REQUIRED)
  find_package(FCGI REQUIRED)
  find_package(Threads REQUIRED)
  if(NOT CMAKE_USE_PTHREADS_INIT)
    message(FATAL_ERROR "Only pthread are supported")
  endif()
endif()
add_subdirectory(src/lib)
option(BUILD_LUTS_GENERATOR "Build utility to generate t1_luts.h" OFF)
option(BUILD_UNIT_TESTS "Build unit tests (bench_dwt, test_sparse_array, etc..)" OFF)

#-----------------------------------------------------------------------------
# Build Applications
option(BUILD_CODEC "Build the CODEC executables" ON)
option(BUILD_MJ2 "Build the MJ2 executables." OFF)
option(BUILD_JPWL "Build the JPWL library and executables" OFF)
option(BUILD_JPIP "Build the JPIP library and executables." OFF)
if(BUILD_JPIP)
  option(BUILD_JPIP_SERVER "Build the JPIP server." OFF)
endif()
option(BUILD_VIEWER "Build the OPJViewer executable (C++)" OFF)
option(BUILD_JAVA "Build the openjpeg jar (Java)" OFF)
option(BUILD_JP3D "Build the JP3D comp" OFF)
mark_as_advanced(BUILD_VIEWER)
mark_as_advanced(BUILD_JAVA)
mark_as_advanced(BUILD_JP3D)

if(BUILD_CODEC OR BUILD_MJ2)
  # OFF: It will only build 3rd party libs if they are not found on the system
  # ON: 3rd party libs will ALWAYS be build, and used
  option(BUILD_THIRDPARTY "Build the thirdparty executables if it is needed" OFF)
  add_subdirectory(thirdparty)
  add_subdirectory(src/bin)
endif ()
add_subdirectory(wrapping)

#-----------------------------------------------------------------------------
# opj_config.h generation (2/2)
configure_file(
 ${CMAKE_CURRENT_SOURCE_DIR}/src/lib/openjp2/opj_config.h.cmake.in
 ${CMAKE_CURRENT_BINARY_DIR}/src/lib/openjp2/opj_config.h
 @ONLY
 )

 configure_file(
 ${CMAKE_CURRENT_SOURCE_DIR}/src/lib/openjp2/opj_config_private.h.cmake.in
 ${CMAKE_CURRENT_BINARY_DIR}/src/lib/openjp2/opj_config_private.h
 @ONLY
 )

#-----------------------------------------------------------------------------
# build documentation in doc subdir:
if(BUILD_DOC)
  add_subdirectory(doc)
endif()

#-----------------------------------------------------------------------------
# Buld Testing
option(BUILD_TESTING "Build the tests." OFF)
if(BUILD_TESTING)
  if(BUILD_CODEC)
    enable_testing()
    include(CTest)

    # Search openjpeg data needed for the tests
    # They could be found via git on the OpenJPEG GitHub code project
    # git clone https://github.com/uclouvain/openjpeg-data.git
    find_path(OPJ_DATA_ROOT README-OPJ-Data
      PATHS $ENV{OPJ_DATA_ROOT} ${CMAKE_SOURCE_DIR}/../data
      NO_DEFAULT_PATH NO_CMAKE_FIND_ROOT_PATH
      )

=== tests/conformance/CMakeLists.txt ===
# CONFORMANCE TESTS AND NON-REGRESSION ON THIS DATASET

file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/Temporary)

set(TEMP ${CMAKE_CURRENT_BINARY_DIR}/Temporary)
set(BASELINE_CONF ${OPJ_DATA_ROOT}/baseline/conformance)
set(BASELINE_NR ${OPJ_DATA_ROOT}/baseline/nonregression)
set(INPUT_CONF ${OPJ_DATA_ROOT}/input/conformance)


# List of components by file (normally p0_13.j2k have 257 components but for this
#set of test we consider only 4)
set( CP0_nbC_list "not_used;1;1;1;3;4;4;3;3;1;3;1;1;4;3;1;1")
set( CP1_nbC_list "not_used;1;3;4;1;3;3;2")

set(COMMENTCODEVAR FALSE)


##--------------------------------------------------------------------------
## Tests about class 0 profile 0
## try to decode
## compare to ref file provided by the Executable Test Suite
## non regression comparison

## Parameters and tolerances given by Table C.1
#set( C0P0_ResFactor_list "not_used;0;0;0;3;3;3;0;5;2;0;0;0;0;2;0;0")
#set( C0P0_PEAK_list "not_used;0;0;0;33;54;109;10;7;4;10;0;0;0;0;0;0")
#set( C0P0_MSE_list "not_used;0;0;0;55.8;68;743;0.34;6.72;1.47;2.84;0;0;0;0;0;0")

#foreach(numFileC0P0 RANGE 1 16)

#  # Build filenames
#  if(${numFileC0P0} LESS 10)
#    set( filenameInput p0_0${numFileC0P0}.j2k )
#    set( filenameRef   c0p0_0${numFileC0P0}.pgx )
#  else()
#    set( filenameInput p0_${numFileC0P0}.j2k )
#    set( filenameRef   c0p0_${numFileC0P0}.pgx )
#  endif()

#  # Get corresponding tests parameters
#  list(GET C0P0_ResFactor_list ${numFileC0P0}  ResFactor)
#  #For Class-0 testing, we always focus on the first component only
#  #list(GET CP0_nbC_list ${numFileC0P0}  nbComponents)
#  set( nbComponents "1")
#  list(GET C0P0_PEAK_list ${numFileC0P0}  PEAK_limit)
#  list(GET C0P0_MSE_list ${numFileC0P0}  MSE_limit)

#  # Manage cases which need to try different resolution reduction
#  if (numFileC0P0 EQUAL 3 OR numFileC0P0 EQUAL 15)
#    get_filename_component(filenameRefSub ${filenameRef} NAME_WE)
#    #r = 0

#    add_test(ETS-C0P0-${filenameInput}-r0-decode
#        ${EXECUTABLE_OUTPUT_PATH}/opj_decompress
#        -i ${INPUT_CONF}/${filenameInput}
#        -o ${TEMP}/c0${filenameInput}-r0.pgx
#        -r 0
#        )

#    add_test(ETS-C0P0-${filenameInput}-r0-compare2ref
#        ${EXECUTABLE_OUTPUT_PATH}/compare_images
#        -b ${BASELINE_CONF}/${filenameRefSub}r0.pgx
#        -t ${TEMP}/c0${filenameInput}-r0.pgx
#        -n ${nbComponents}
#        -p ${PEAK_limit}
#        -m ${MSE_limit}
#        -s t_
#        )

#    set_tests_properties(ETS-C0P0-${filenameInput}-r0-compare2ref
#                         PROPERTIES DEPENDS
#                         ETS-C0P0-${filenameInput}-r0-decode)

#    add_test(NR-C0P0-${filenameInput}-r0-compare2base
#        ${EXECUTABLE_OUTPUT_PATH}/compare_images
#        -b ${BASELINE_NR}/opj_${filenameRefSub}-r0.pgx
#        -t ${TEMP}/c0${filenameInput}-r0.pgx
#        -n ${nbComponents}
#        -d
#        -s b_t_
#        )

#    set_tests_properties(NR-C0P0-${filenameInput}-r0-compare2base
#                         PROPERTIES DEPENDS
#                         ETS-C0P0-${filenameInput}-r0-decode)

#    #r = 1
#    add_test(ETS-C0P0-${filenameInput}-r1-decode
#        ${EXECUTABLE_OUTPUT_PATH}/opj_decompress
#        -i ${INPUT_CONF}/${filenameInput}
#        -o ${TEMP}/c0${filenameInput}-r1.pgx
#        -r 1
#        )

#    add_test(ETS-C0P0-${filenameInput}-r1-compare2ref
#        ${EXECUTABLE_OUTPUT_PATH}/compare_images
#        -b ${BASELINE_CONF}/${filenameRefSub}r1.pgx
#        -t ${TEMP}/c0${filenameInput}-r1.pgx
#        -n ${nbComponents}
#        -p ${PEAK_limit}
#        -m ${MSE_limit}
#        -s t_
#        )

#    set_tests_properties(ETS-C0P0-${filenameInput}-r1-compare2ref
#                         PROPERTIES DEPENDS
#                         ETS-C0P0-${filenameInput}-r1-decode)

#    add_test(NR-C0P0-${filenameInput}-r1-compare2base
#        ${EXECUTABLE_OUTPUT_PATH}/compare_images
#        -b ${BASELINE_NR}/opj_${filenameRefSub}-r1.pgx
#        -t ${TEMP}/c0${filenameInput}-r1.pgx
#        -n ${nbComponents}
#        -d
#        -s b_t_
#        )

#    set_tests_properties(NR-C0P0-${filenameInput}-r1-compare2base
#                         PROPERTIES DEPENDS
#                         ETS-C0P0-${filenameInput}-r1-decode)

#  else()

#    add_test(ETS-C0P0-${filenameInput}-decode
#        ${EXECUTABLE_OUTPUT_PATH}/opj_decompress
#        -i ${INPUT_CONF}/${filenameInput}
#        -o ${TEMP}/c0${filenameInput}.pgx
#        -r ${ResFactor}
#        )

#    add_test(ETS-C0P0-${filenameInput}-compare2ref
#        ${EXECUTABLE_OUTPUT_PATH}/compare_images
#        -b ${BASELINE_CONF}/${filenameRef}
#        -t ${TEMP}/c0${filenameInput}.pgx
#        -n ${nbComponents}
#        -p ${PEAK_limit}
#        -m ${MSE_limit}
#        -s t_
#        )

#    set_tests_properties(ETS-C0P0-${filenameInput}-compare2ref
#                         PROPERTIES DEPENDS
#                         ETS-C0P0-${filenameInput}-decode)

#    add_test(NR-C0P0-${filenameInput}-compare2base
#        ${EXECUTABLE_OUTPUT_PATH}/compare_images
#        -b ${BASELINE_NR}/opj_${filenameRef}
#        -t ${TEMP}/c0${filenameInput}.pgx
#        -n ${nbComponents}
#        -d
#        -s b_t_
#        )

#    set_tests_properties(NR-C0P0-${filenameInput}-compare2base
#                         PROPERTIES DEPENDS
#                         ETS-C0P0-${filenameInput}-decode)

#  endif()

#endforeach()

##--------------------------------------------------------------------------
## Tests about class 0 profile 1
## try to decode
## compare to ref file
## non regression comparison

## Parameters and tolerances given by Table C.4
#set( C0P1_ResFactor_list "not_used;0;3;3;0;4;1;0")
#set( C0P1_PEAK_list "not_used;0;35;28;2;128;128;0")
#set( C0P1_MSE_list "not_used;0;74;18.8;0.550;16384;16384;0")

#foreach(numFileC0P1 RANGE 1 7)

#  # Build filenames
#  set( filenameInput p1_0${numFileC0P1}.j2k )
#  set( filenameRef   c0p1_0${numFileC0P1}.pgx )

#  # Get corresponding tests parameters
#  list(GET C0P1_ResFactor_list ${numFileC0P1}  ResFactor)
#  #For Class-0 testing, we always focus on the first component only
#  #list(GET CP0_nbC_list ${numFileC0P0}  nbComponents)
#  set( nbComponents "1")
#  list(GET C0P1_PEAK_list ${numFileC0P1}  PEAK_limit)
#  list(GET C0P1_MSE_list ${numFileC0P1}  MSE_limit)

#  # Manage cases which need to try different resolution reduction
#  if (numFileC0P1 EQUAL 4 )
#    get_filename_component(filenameRefSub ${filenameRef} NAME_WE)

#    #r = 0
#    add_test(ETS-C0P1-${filenameInput}-r0-decode
#        ${EXECUTABLE_OUTPUT_PATH}/opj_decompress
#        -i ${INPUT_CONF}/${filenameInput}
#        -o ${TEMP}/c0${filenameInput}-r0.pgx
#        -r 0
#        )

#    add_test(ETS-C0P1-${filenameInput}-r0-compare2ref
#        ${EXECUTABLE_OUTPUT_PATH}/compare_images
#        -b ${BASELINE_CONF}/${filenameRefSub}r0.pgx
#        -t ${TEMP}/c0${filenameInput}-r0.pgx
#        -n ${nbComponents}
#        -p ${PEAK_limit}
#        -m ${MSE_limit}
#        -s t_
#        )

#    set_tests_properties(ETS-C0P1-${filenameInput}-r0-compare2ref
#                         PROPERTIES DEPENDS
#                         ETS-C0P1-${filenameInput}-r0-decode)

#    add_test(NR-C0P1-${filenameInput}-r0-compare2base
#        ${EXECUTABLE_OUTPUT_PATH}/compare_images
#        -b ${BASELINE_NR}/opj_${filenameRefSub}-r0.pgx
#        -t ${TEMP}/c0${filenameInput}-r0.pgx
#        -n ${nbComponents}
#        -d
#        -s b_t_
#        )

#    set_tests_properties(NR-C0P1-${filenameInput}-r0-compare2base
#                         PROPERTIES DEPENDS
#                         ETS-C0P1-${filenameInput}-r0-decode)

#    #r = 3
#    add_test(ETS-C0P1-${filenameInput}-r3-decode
#        ${EXECUTABLE_OUTPUT_PATH}/opj_decompress
#        -i ${INPUT_CONF}/${filenameInput}
#        -o ${TEMP}/c0${filenameInput}-r3.pgx
#        -r 3
#        )

#    add_test(ETS-C0P1-${filenameInput}-r3-compare2ref
#        ${EXECUTABLE_OUTPUT_PATH}/compare_images
#        -b ${BASELINE_CONF}/${filenameRefSub}r3.pgx
#        -t ${TEMP}/c0${filenameInput}-r3.pgx
#        -n ${nbComponents}
#        -p ${PEAK_limit}
#        -m ${MSE_limit}
#        -s t_
#        )

#    set_tests_properties(ETS-C0P1-${filenameInput}-r3-compare2ref
#                         PROPERTIES DEPENDS
#                         ETS-C0P1-${filenameInput}-r3-decode)

#    add_test(NR-C0P1-${filenameInput}-r3-compare2base
#        ${EXECUTABLE_OUTPUT_PATH}/compare_images
#        -b ${BASELINE_NR}/opj_${filenameRefSub}-r3.pgx
#        -t ${TEMP}/c0${filenameInput}-r3.pgx
#        -n ${nbComponents}
#        -d
#        -s b_t_
#        )

#    set_tests_properties(NR-C0P1-${filenameInput}-r3-compare2base
#                         PROPERTIES DEPENDS
#                         ETS-C0P1-${filenameInput}-r3-decode)

#  else()

#    add_test(ETS-C0P1-${filenameInput}-decode
#        ${EXECUTABLE_OUTPUT_PATH}/opj_decompress
#        -i ${INPUT_CONF}/${filenameInput}
#        -o ${TEMP}/c0${filenameInput}.pgx
#        -r ${ResFactor}
#        )

#    add_test(ETS-C0P1-${filenameInput}-compare2ref
#        ${EXECUTABLE_OUTPUT_PATH}/compare_images
#        -b ${BASELINE_CONF}/${filenameRef}
#        -t ${TEMP}/c0${filenameInput}.pgx
#        -n ${nbComponents}
#        -p ${PEAK_limit}
#        -m ${MSE_limit}
#        -s t_
#        )

#    set_tests_properties(ETS-C0P1-${filenameInput}-compare2ref
#                         PROPERTIES DEPENDS
#                         ETS-C0P1-${filenameInput}-decode)

#    add_test(NR-C0P1-${filenameInput}-compare2base
#        ${EXECUTABLE_OUTPUT_PATH}/compare_images
#        -b ${BASELINE_NR}/opj_${filenameRef}
#        -t ${TEMP}/c0${filenameInput}.pgx
#        -n ${nbComponents}
#        -d
#        -s b_t_
#        )

#    set_tests_properties(NR-C0P1-${filenameInput}-compare2base
#                         PROPERTIES DEPENDS
#                         ETS-C0P1-${filenameInput}-decode)

#  endif()

#endforeach()

#--------------------------------------------------------------------------
# Tests about class 1 profile 0
# try to decode
# compare to ref file
# non regression comparison

# Parameters and tolerances given by Table C.6
set( C1P0_ResFactor_list "not_used;0;0;0;0;0;0;0;1;0;0;0;0;0;0;0;0")
set( C1P0_PEAK_list "not_used;0;0;0;5:4:6;2:2:2:0;635:403:378:0;0:0:0;0:0:0;0;0:0:0;0;0;0:0:0:0;0:0:0;0;0")
set( C1P0_MSE_list  "not_used;0;0;0;0.776:0.626:1.070;0.302:0.307:0.269:0;11287:6124:3968:0;0:0:0;0:0:0;0;0:0:0;0;0;0:0:0:0;0:0:0;0;0")

foreach(numFileC1P0 RANGE 1 16)

  # Build filenames
  if(${numFileC1P0} LESS 10)
    set( filenameInput p0_0${numFileC1P0}.j2k )
    set( filenameRef   c1p0_0${numFileC1P0}.pgx )
  else()
    set( filenameInput p0_${numFileC1P0}.j2k )
    set( filenameRef   c1p0_${numFileC1P0}.pgx )
  endif()

  # Get corresponding tests parameters
  list(GET CP0_nbC_list ${numFileC1P0}  nbComponents)
  list(GET C1P0_ResFactor_list ${numFileC1P0}  ResFactor)
  list(GET C1P0_PEAK_list ${numFileC1P0}  PEAK_limit)
  list(GET C1P0_MSE_list ${numFileC1P0}  MSE_limit)

  add_test(NAME ETS-C1P0-${filenameInput}-decode
      COMMAND opj_decompress
      -i ${INPUT_CONF}/${filenameInput}
      -o ${TEMP}/c1${filenameInput}.pgx
      -r ${ResFactor}
      )

  add_test(NAME ETS-C1P0-${filenameInput}-compare2ref
      COMMAND compare_images
     -b ${BASELINE_CONF}/${filenameRef}
     -t ${TEMP}/c1${filenameInput}.pgx
     -n ${nbComponents}
     -p ${PEAK_limit}
     -m ${MSE_limit}
     -s b_t_
     )

  set_tests_properties(ETS-C1P0-${filenameInput}-compare2ref
                       PROPERTIES DEPENDS
                       ETS-C1P0-${filenameInput}-decode)

  add_test(NAME NR-C1P0-${filenameInput}-compare2base
      COMMAND compare_images
     -b ${BASELINE_NR}/opj_${filenameRef}
     -t ${TEMP}/c1${filenameInput}.pgx
     -n ${nbComponents}
     -d
     -s b_t_
     )

  set_tests_properties(NR-C1P0-${filenameInput}-compare2base
                       PROPERTIES DEPENDS

=== tests/nonregression/CMakeLists.txt ===
# NON-REGRESSION TESTS ON THIS DATASET LOCATED ${OPJ_DATA_ROOT}/input/nonregression

cmake_minimum_required(VERSION 2.8.7)

file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/Temporary)

set(TEMP ${CMAKE_CURRENT_BINARY_DIR}/Temporary)
set(BASELINE_NR ${OPJ_DATA_ROOT}/baseline/nonregression)
set(INPUT_NR ${OPJ_DATA_ROOT}/input/nonregression)


set(INPUT_NR_PATH ${INPUT_NR})
set(TEMP_PATH ${TEMP})
set(INPUT_CONF_PATH ${OPJ_DATA_ROOT}/input/conformance)

# need kdu_expand if possible
find_package(KAKADU)
# need jpylyzer if possible
find_package(JPYLYZER)

#########################################################################
# GENERATION OF THE TEST SUITE (DUMP)
# Dump all files with the selected extension inside the input directory

# technically opj_dump should simply parse these one, since syntax is ok.
set(BLACKLIST_JPEG2000_TMP
    2539.pdf.SIGFPE.706.1712.jp2
    0290cb77c5df21828fa74cf2ab2c84d8.SIGFPE.d25.31.jp2
    26ccf3651020967f7778238ef5af08af.SIGFPE.d25.527.jp2
    4035.pdf.SIGSEGV.d8b.3375.jp2
    3635.pdf.asan.77.2930.jp2
    issue165.jp2
    #edf_c2_1103421.jp2
    edf_c2_1178956.jp2
    edf_c2_1000290.jp2
    #edf_c2_1000691.jp2 # ok
    #edf_c2_20.jp2 #looks ok as per kdu_jp2info
    edf_c2_1377017.jp2
    edf_c2_1002767.jp2
    edf_c2_10025.jp2
    edf_c2_1000234.jp2
    edf_c2_225881.jp2
    edf_c2_1000671.jp2
    #edf_c2_1013627.jp2 # weird box, but kdu_jp2info ok
    edf_c2_1015644.jp2
    edf_c2_101463.jp2
    edf_c2_1674177.jp2
    edf_c2_1673169.jp2
    issue418.jp2
    issue429.jp2
    issue427-null-image-size.jp2
    issue427-illegal-tile-offset.jp2
    issue495.jp2
    issue820.jp2
   )

# Define a list of file which should be gracefully rejected:
set(BLACKLIST_JPEG2000
    ${BLACKLIST_JPEG2000_TMP}
    broken1.jp2
    broken2.jp2
    broken3.jp2
    broken4.jp2
    gdal_fuzzer_assert_in_opj_j2k_read_SQcd_SQcc.patch.jp2	
    gdal_fuzzer_check_comp_dx_dy.jp2
    gdal_fuzzer_check_number_of_tiles.jp2
    gdal_fuzzer_unchecked_numresolutions.jp2
    mem-b2ace68c-1381.jp2
    1851.pdf.SIGSEGV.ce9.948.jp2
    1888.pdf.asan.35.988.jp2
    issue362-2863.jp2 #kdu_jp2info ok
    issue362-2866.jp2
    issue362-2894.jp2
    issue400.jp2 #kdu_jp2info ok
    issue364-38.jp2
    issue364-903.jp2 #kdu_jp2info ok
    issue393.jp2 #kdu_jp2info ok
    issue408.jp2 #kdu_jp2info ok
    issue420.jp2 #kdu_jp2info ok
    27ac957758a35d00d6765a0c86350d9c.SIGFPE.d25.537.jpc #kdu_jp2info crash
    3672da2f1f67bbecad27d7181b4e9d7c.SIGFPE.d25.805.jpc #kdu_jp2info crash
    issue475.jp2 #kdu_jp2info ok
    issue413.jp2 #kdu_jp2info ok
    issue823.jp2 #kdu_jp2info ok
   )

file(GLOB_RECURSE OPJ_DATA_NR_LIST
     "${INPUT_NR}/*.j2k"
     "${INPUT_NR}/*.j2c"
     "${INPUT_NR}/*.jp2"
     "${INPUT_NR}/*.jpc"
     #"${INPUT_NR}/*.jpx"
     )

foreach(INPUT_FILENAME ${OPJ_DATA_NR_LIST})
  get_filename_component(INPUT_FILENAME_NAME ${INPUT_FILENAME} NAME)
  #get_filename_component(INPUT_FILENAME_NAME_WE ${INPUT_FILENAME_NAME} NAME_WE)
  # cannot use longest extension function, since some name contains multiples
  # dots. Instead write out own shortest extension function:
  string(FIND ${INPUT_FILENAME_NAME} "." SHORTEST_EXT_POS REVERSE)
  string(SUBSTRING ${INPUT_FILENAME_NAME} 0 ${SHORTEST_EXT_POS} INPUT_FILENAME_NAME_WE)
  string(REGEX MATCH ${INPUT_FILENAME_NAME} bad_jpeg2000 ${BLACKLIST_JPEG2000})

  # Dump the input image
  add_test(NAME NR-${INPUT_FILENAME_NAME}-dump
           COMMAND opj_dump
  	       -i ${INPUT_FILENAME}
  	       -o ${TEMP}/${INPUT_FILENAME_NAME}.txt
  	       -v
  	       )
  	
  if(bad_jpeg2000)
    set_tests_properties(NR-${INPUT_FILENAME_NAME}-dump
                         PROPERTIES WILL_FAIL TRUE)

  else()
  	
    # Compare the dump output with the baseline
    add_test(NAME NR-${INPUT_FILENAME_NAME}-compare_dump2base
  	        COMMAND compare_dump_files
            -b ${BASELINE_NR}/opj_v2_${INPUT_FILENAME_NAME_WE}.txt
            -t ${TEMP}/${INPUT_FILENAME_NAME}.txt
            )

    set_tests_properties(NR-${INPUT_FILENAME_NAME}-compare_dump2base
                         PROPERTIES DEPENDS
                         NR-${INPUT_FILENAME_NAME}-dump)
  endif()

endforeach()


#########################################################################
# GENERATION OF THE TEST SUITE (DECODE AND ENCODE)
# Read one and more input file(s) (located in ${OPJ_DATA_ROOT}/input/nonregression)
# to know which files processed and with which options.

# Configure the test suite file:
configure_file("test_suite.ctest.in"
               "${CMAKE_CURRENT_BINARY_DIR}/test_suite.ctest"
               @ONLY)

# Read the file into a list
file(STRINGS ${CMAKE_CURRENT_BINARY_DIR}/test_suite.ctest OPJ_TEST_CMD_LINE_LIST)

# Try to find and configure and read another test suite file
file(GLOB TEST_SUITE_FILES *.ctest.in)
if (TEST_SUITE_FILES)
  foreach(TEST_SUITE_FILE ${TEST_SUITE_FILES})

    # Avoid to process the official test suite
    set(FILE_ALREADY_READ 0)
    get_filename_component(TEST_SUITE_FILENAME ${TEST_SUITE_FILE} NAME)
    string(REGEX MATCH "^test_suite.ctest.in$" FILE_ALREADY_READ ${TEST_SUITE_FILENAME})

    if(NOT FILE_ALREADY_READ)
      # Configure the additional test suite file:
      get_filename_component(TEST_SUITE_FILE_SUB ${TEST_SUITE_FILE} NAME_WE)
      configure_file("${TEST_SUITE_FILE}"
                     "${CMAKE_CURRENT_BINARY_DIR}/${TEST_SUITE_FILE_SUB}.ctest"
                     @ONLY)
      # Read the additional file into a list
      file(STRINGS ${CMAKE_CURRENT_BINARY_DIR}/${TEST_SUITE_FILE_SUB}.ctest OPJ_TEST_CMD_LINE_LIST_TEMP)
      # Append the list of command
      set(OPJ_TEST_CMD_LINE_LIST ${OPJ_TEST_CMD_LINE_LIST} ${OPJ_TEST_CMD_LINE_LIST_TEMP})

    endif()

  endforeach()

else()

  message(FATAL_ERROR "One test suite should be available (test_suite.ctest.in) !!!")

endif()


set(nonregression_filenames_used)
# Parse the command line found in the file(s)
set(IT_TEST_ENC 0)
set(IT_TEST_DEC 0)
foreach(OPJ_TEST_CMD_LINE ${OPJ_TEST_CMD_LINE_LIST})

  set(IGNORE_LINE_FOUND 0)

  # Replace space by ; to generate a list
  string(REPLACE " " ";" CMD_ARG_LIST ${OPJ_TEST_CMD_LINE})

  # Check if the first argument begin by the comment sign
  list(GET CMD_ARG_LIST 0 EXE_NAME)

  if(EXE_NAME)
    string(REGEX MATCH "^#" IGNORE_LINE_FOUND ${EXE_NAME})
  endif()

  if(IGNORE_LINE_FOUND OR NOT EXE_NAME)

    #message( STATUS "Current line is ignored: ${OPJ_TEST_CMD_LINE}")

  else()

    # Check if the first argument begin by the failed sign
    set(FAILED_TEST_FOUND 0)
    string(REGEX MATCH "^!" FAILED_TEST_FOUND ${EXE_NAME})

    if (FAILED_TEST_FOUND)
      # Manage the different cases with the failed sign to remove the first argument which must be opj_compress
      set(FAILED_TEST_FOUND_1 0)
      string(REGEX MATCH "^!opj_compress$|^!opj_decompress$" FAILED_TEST_FOUND_1 ${EXE_NAME})

      if (FAILED_TEST_FOUND_1)

        list(REMOVE_AT CMD_ARG_LIST 0)

      else ()

        set(FAILED_TEST_FOUND_2 0)
        list(GET CMD_ARG_LIST 1 EXE_NAME)
        string(REGEX MATCH "^opj_compress$|^opj_decompress$" FAILED_TEST_FOUND_2 ${EXE_NAME})

        if (FAILED_TEST_FOUND_2)

          list(REMOVE_AT CMD_ARG_LIST 0)
          list(REMOVE_AT CMD_ARG_LIST 0)

        else ()

          message( FATAL_ERROR "${EXE_NAME} is not the right executable name to encode file (try to use opj_compress or opj_decompress)")

        endif ()
      endif ()

    else ()
      # Check if the first argument is equal to opj_compress
      string(REGEX MATCH "^opj_compress$|^opj_decompress$" EXE_NAME_FOUND ${EXE_NAME})

      if(EXE_NAME_FOUND)

        string(REGEX MATCH "opj_compress" ENC_TEST_FOUND ${EXE_NAME})

      else()

        message( FATAL_ERROR "${EXE_NAME} is not the right executable name to encode file (try to use opj_compress)")

      endif()

      list(REMOVE_AT CMD_ARG_LIST 0)

    endif ()

    # Parse the argument list to find the input filename and output filename
    set(CMD_ARG_LIST_2 "")
    set(ARG_POS 0)
    set(INPUT_ARG_POS 0)
    set(OUTPUT_ARG_POS 0)

    foreach(CMD_ARG_ELT ${CMD_ARG_LIST})

      math(EXPR ARG_POS "${ARG_POS}+1" )

      string(COMPARE EQUAL ${CMD_ARG_ELT} "-i" INPUT_ARG_FOUND)
      if(INPUT_ARG_FOUND)
        set(INPUT_ARG_POS ${ARG_POS})
        set(INPUT_ARG_FOUND 0)
      endif()

      string(COMPARE EQUAL ${CMD_ARG_ELT} "-o" OUTPUT_ARG_FOUND)
      if(OUTPUT_ARG_FOUND)
        set(OUTPUT_ARG_POS ${ARG_POS})
        set(OUTPUT_ARG_FOUND 0)
      endif()

      list (APPEND CMD_ARG_LIST_2 ${CMD_ARG_ELT})

    endforeach()

    list(GET CMD_ARG_LIST_2 ${INPUT_ARG_POS} INPUT_FILENAME)
    get_filename_component(INPUT_FILENAME_NAME ${INPUT_FILENAME} NAME)
    get_filename_component(INPUT_FILENAME_NAME_WE ${INPUT_FILENAME_NAME} NAME_WE)
    list(GET CMD_ARG_LIST_2 ${OUTPUT_ARG_POS} OUTPUT_FILENAME)
    get_filename_component(OUTPUT_FILENAME_NAME_WE ${OUTPUT_FILENAME} NAME_WE)

    #-----
    # Now we can add the test suite corresponding to a line command in the file
    #-----
    # ENCODER TEST SUITE
    if(ENC_TEST_FOUND)
        math(EXPR IT_TEST_ENC "${IT_TEST_ENC}+1" )

        # Encode an image into the jpeg2000 format
        add_test(NAME NR-ENC-${INPUT_FILENAME_NAME}-${IT_TEST_ENC}-encode
          COMMAND opj_compress
          ${CMD_ARG_LIST_2}
        )

        if(FAILED_TEST_FOUND)
            set_tests_properties(NR-ENC-${INPUT_FILENAME_NAME}-${IT_TEST_ENC}-encode PROPERTIES WILL_FAIL TRUE)
        else()

          # Dump the encoding file
          add_test(NAME NR-ENC-${INPUT_FILENAME_NAME}-${IT_TEST_ENC}-dump
            COMMAND opj_dump
            -i ${OUTPUT_FILENAME}
            -o ${OUTPUT_FILENAME}-ENC-${IT_TEST_ENC}.txt
          )
          set_tests_properties(NR-ENC-${INPUT_FILENAME_NAME}-${IT_TEST_ENC}-dump
                               PROPERTIES DEPENDS
                               NR-ENC-${INPUT_FILENAME_NAME}-${IT_TEST_ENC}-encode)

          # Compare the dump file with the baseline
          add_test(NAME NR-ENC-${INPUT_FILENAME_NAME}-${IT_TEST_ENC}-compare_dump2base
            COMMAND compare_dump_files
            -b ${BASELINE_NR}/opj_v2_${OUTPUT_FILENAME_NAME_WE}-ENC-${IT_TEST_ENC}.txt
            -t ${OUTPUT_FILENAME}-ENC-${IT_TEST_ENC}.txt
          )

          set_tests_properties(NR-ENC-${INPUT_FILENAME_NAME}-${IT_TEST_ENC}-compare_dump2base
                               PROPERTIES DEPENDS
                               NR-ENC-${INPUT_FILENAME_NAME}-${IT_TEST_ENC}-dump)

          # Decode the encoding file with kakadu expand command
          if (KDU_EXPAND_EXECUTABLE)
            add_test(NAME NR-ENC-${INPUT_FILENAME_NAME}-${IT_TEST_ENC}-decode-ref
              COMMAND ${KDU_EXPAND_EXECUTABLE}
              -i ${OUTPUT_FILENAME}
              -o ${OUTPUT_FILENAME}.raw
              )

            set_tests_properties(NR-ENC-${INPUT_FILENAME_NAME}-${IT_TEST_ENC}-decode-ref
                                 PROPERTIES DEPENDS
                                 NR-ENC-${INPUT_FILENAME_NAME}-${IT_TEST_ENC}-encode)

            # Compare the decoding file with baseline generated from the kdu_expand and baseline.j2k
            add_test(NAME NR-ENC-${INPUT_FILENAME_NAME}-${IT_TEST_ENC}-compare_dec-ref-out2base
              COMMAND compare_raw_files
              -b ${BASELINE_NR}/opj_${OUTPUT_FILENAME_NAME_WE}-ENC-${IT_TEST_ENC}.raw
              -t ${OUTPUT_FILENAME}.raw
            )

            set_tests_properties(NR-ENC-${INPUT_FILENAME_NAME}-${IT_TEST_ENC}-compare_dec-ref-out2base
                                 PROPERTIES DEPENDS
                                 NR-ENC-${INPUT_FILENAME_NAME}-${IT_TEST_ENC}-decode-ref)

          endif()

          # Test the encoded file is a valid JP2 file
          if (JPYLYZER_EXECUTABLE)
            if (${OUTPUT_FILENAME} MATCHES "\\.jp2$")
              add_test(NAME NR-ENC-${INPUT_FILENAME_NAME}-${IT_TEST_ENC}-jpylyser
                COMMAND ${JPYLYZER_EXECUTABLE}
                ${OUTPUT_FILENAME}

=== thirdparty/libtiff/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
project(libtiff C)
# This convenient copy of libtiff does not support encapsulated zlib or jpeg
# stream. see ZIP_SUPPORT and JPEG_SUPPORT values

include_directories(BEFORE "${CMAKE_CURRENT_SOURCE_DIR}")
include_directories(BEFORE "${CMAKE_CURRENT_BINARY_DIR}")

set(TARGET_FILES
  t4.h
  tiffiop.h
  tif_aux.c
  tif_close.c
  tif_codec.c
  tif_color.c
  tif_compress.c
  tif_dir.c
  tif_dir.h
  tif_dirinfo.c
  tif_dirread.c
  tif_dirwrite.c
  tif_dumpmode.c
  tif_error.c
  tif_extension.c
  tif_fax3.c
  tif_fax3.h
  tif_fax3sm.c
  tif_flush.c
  tif_getimage.c
  tif_jbig.c
  tif_jpeg.c
  tif_luv.c
  tif_lzw.c
  tif_next.c
  tif_ojpeg.c
  tif_open.c
  tif_packbits.c
  tif_pixarlog.c
  tif_predict.c
  tif_predict.h
  tif_print.c
  tif_read.c
  tif_strip.c
  tif_swab.c
  tif_thunder.c
  tif_tile.c
  tif_version.c
  tif_warning.c
  tif_write.c
  tif_zip.c
  tif_jpeg_12.c
  tif_lzma.c
  uvcode.h
  )

if(UNIX)
  set(TARGET_FILES ${TARGET_FILES} tif_unix.c)
  # Large file support
  # This might not catch every possibility catered for by
  # AC_SYS_LARGEFILE.
  add_definitions(-D_FILE_OFFSET_BITS=64)
  set(_FILE_OFFSET_BITS 64)
else()
  set(TARGET_FILES ${TARGET_FILES} tif_win32.c)
endif()

include(${CMAKE_ROOT}/Modules/TestBigEndian.cmake)
TEST_BIG_ENDIAN(WORDS_BIGENDIAN)
set(HOST_BIGENDIAN ${WORDS_BIGENDIAN})
if(HOST_BIGENDIAN)
set(HOST_FILLORDER "FILLORDER_MSB2LSB")
else()
set(HOST_FILLORDER "FILLORDER_LSB2MSB")
endif()
include(CheckIncludeFiles)
include(CheckSymbolExists)
include(CheckFunctionExists)
include(CheckCSourceCompiles)

CHECK_INCLUDE_FILES("zlib.h" HAVE_ZLIB_H)
CHECK_INCLUDE_FILES("jpeglib.h" HAVE_JPEGLIB_H)
if(HAVE_JPEGLIB_H)
  set(JPEG_SUPPORT 1)
endif()
if(HAVE_ZLIB_H)
  include_directories(
    ${ZLIB_INCLUDE_DIR}
    )
  set(ZIP_SUPPORT 1)
  set(PIXARLOG_SUPPORT 1) # require zlib
endif()
CHECK_INCLUDE_FILES("assert.h" HAVE_ASSERT_H)
CHECK_INCLUDE_FILES("dlfcn.h" HAVE_DLFCN_H)
CHECK_INCLUDE_FILES("fcntl.h" HAVE_FCNTL_H)
CHECK_INCLUDE_FILES("inttypes.h" HAVE_INTTYPES_H)
CHECK_INCLUDE_FILES("io.h" HAVE_IO_H)
CHECK_INCLUDE_FILES("limits.h" HAVE_LIMITS_H)
CHECK_INCLUDE_FILES("malloc.h" HAVE_MALLOC_H)
CHECK_INCLUDE_FILES("memory.h" HAVE_MEMORY_H)
CHECK_INCLUDE_FILES("search.h" HAVE_SEARCH_H)
CHECK_INCLUDE_FILES("stdint.h" HAVE_STDINT_H)
CHECK_INCLUDE_FILES("stdlib.h" HAVE_STDLIB_H)
CHECK_INCLUDE_FILES("string.h" HAVE_STRING_H)
CHECK_INCLUDE_FILES("strings.h" HAVE_STRINGS_H)
CHECK_INCLUDE_FILES("sys/stat.h" HAVE_SYS_STAT_H)
CHECK_INCLUDE_FILES("sys/time.h" HAVE_SYS_TIME_H)
CHECK_INCLUDE_FILES("time.h" HAVE_TIME_H)
CHECK_INCLUDE_FILES("sys/types.h" HAVE_SYS_TYPES_H)
CHECK_INCLUDE_FILES("unistd.h" HAVE_UNISTD_H)
CHECK_INCLUDE_FILES("windows.h" HAVE_WINDOWS_H)
CHECK_INCLUDE_FILES("strings.h" HAVE_STRINGS_H)
CHECK_INCLUDE_FILES("ieeefp.h" HAVE_IEEEFP_H)

# wotsit ?
if( HAVE_TIME_H AND HAVE_SYS_TIME_H )
 set(TIME_WITH_SYS_TIME 1)
endif()
set(LZMA_SUPPORT 0) # ?
set(MDI_SUPPORT 1) # ?
set(STDC_HEADERS 1) # why not ?
set(DEFAULT_EXTRASAMPLE_AS_ALPHA 1)
set(CHECK_JPEG_YCBCR_SUBSAMPLING 1)
set(CCITT_SUPPORT 1)
set(DEFER_STRILE_LOAD 0)
set(HAVE_JBG_NEWLEN 0) # FIXME: jbigkit stuff
set(STRIPCHOP_DEFAULT "TIFF_STRIPCHOP")
set(STRIP_SIZE_DEFAULT 8192)
set(SUBIFD_SUPPORT 1)
set(THUNDER_SUPPORT 1)

CHECK_FUNCTION_EXISTS(getopt HAVE_GETOPT)
CHECK_FUNCTION_EXISTS(isascii HAVE_ISASCII)
CHECK_FUNCTION_EXISTS(memmove HAVE_MEMMOVE)
CHECK_FUNCTION_EXISTS(memset HAVE_MEMSET)
CHECK_FUNCTION_EXISTS(mmap HAVE_MMAP)
CHECK_FUNCTION_EXISTS(strcasecmp HAVE_STRCASECMP)
CHECK_FUNCTION_EXISTS(strchr HAVE_STRCHR)
CHECK_FUNCTION_EXISTS(strrchr HAVE_STRRCHR)
CHECK_FUNCTION_EXISTS(strstr HAVE_STRSTR)
CHECK_FUNCTION_EXISTS(strtol HAVE_STRTOL)
CHECK_FUNCTION_EXISTS(strtoul HAVE_STRTOUL)
CHECK_FUNCTION_EXISTS(strtoull HAVE_STRTOULL)

# May be inlined, so check it compiles:
check_c_source_compiles("
#include <stdio.h>
int main(void) {
  char buf[10];
  snprintf(buf, 10, \"Test %d\", 1);
  return 0;
}" HAVE_SNPRINTF)

if(NOT HAVE_SNPRINTF)
  set(TARGET_FILES ${TARGET_FILES} snprintf.c)
endif()

include(CheckTypeSize)

CHECK_TYPE_SIZE("signed int"         SIZEOF_SIGNED_INT)
CHECK_TYPE_SIZE("signed long"        SIZEOF_SIGNED_LONG)
CHECK_TYPE_SIZE("signed long long"   SIZEOF_SIGNED_LONG_LONG)
CHECK_TYPE_SIZE("signed short"       SIZEOF_SIGNED_SHORT)
CHECK_TYPE_SIZE("unsigned int"       SIZEOF_UNSIGNED_INT)
CHECK_TYPE_SIZE("unsigned long"      SIZEOF_UNSIGNED_LONG)
CHECK_TYPE_SIZE("unsigned long long" SIZEOF_UNSIGNED_LONG_LONG)
CHECK_TYPE_SIZE("unsigned short"     SIZEOF_UNSIGNED_SHORT)
CHECK_TYPE_SIZE("unsigned char*"     SIZEOF_UNSIGNED_CHAR_P)
# check platform has ssize_t:
CHECK_TYPE_SIZE(ssize_t     SSIZE_T)

if(HAVE_STDINT_H)
  set(TIFF_INT8_T    int8_t)
  set(TIFF_INT16_T   int16_t)
  set(TIFF_INT32_T   int32_t)
  set(TIFF_INT64_T   int64_t)
  set(TIFF_UINT8_T   uint8_t)
  set(TIFF_UINT16_T  uint16_t)
  set(TIFF_UINT32_T  uint32_t)
  set(TIFF_UINT64_T  uint64_t)
  set(TIFF_PTRDIFF_T ptrdiff_t)
  if(NOT HAVE_SSIZE_T)
    if("${CMAKE_SIZEOF_VOID_P}" EQUAL 8)
      set(TIFF_SSIZE_T   int64_t)
      set(TIFF_SSIZE_FORMAT "%lld")
      set(TIFF_SIZE_FORMAT "%llu")
    elseif("${CMAKE_SIZEOF_VOID_P}" EQUAL 4)
      set(TIFF_SSIZE_T   int32_t)
      set(TIFF_SSIZE_FORMAT "%d")
      set(TIFF_SIZE_FORMAT "%u")
    else()
      message(FATAL_ERROR "unknown ssize_t")
    endif()
  else()
    set(TIFF_SSIZE_T   ssize_t)
  endif()
  set(TIFF_INT32_FORMAT "%d")
  set(TIFF_UINT32_FORMAT "%u")
  set(TIFF_INT64_FORMAT "%lld")
  set(TIFF_UINT64_FORMAT "%llu")
  set(TIFF_PTRDIFF_FORMAT "%ld")
else()
  set(TIFF_INT8_T    "signed __int8")
  set(TIFF_INT16_T   "signed __int16")
  set(TIFF_INT32_T   "signed __int32")
  set(TIFF_INT64_T   "signed __int64")
  set(TIFF_UINT8_T   "unsigned __int8")
  set(TIFF_UINT16_T  "unsigned __int16")
  set(TIFF_UINT32_T  "unsigned __int32")
  set(TIFF_UINT64_T  "unsigned __int64")
  set(TIFF_PTRDIFF_T ptrdiff_t)
  if(NOT HAVE_SSIZE_T)
    if("${CMAKE_SIZEOF_VOID_P}" EQUAL 8)
      set(TIFF_SSIZE_T   "signed __int64")
      set(TIFF_SSIZE_FORMAT "%lld")
      set(TIFF_SIZE_FORMAT "%llu")
    elseif("${CMAKE_SIZEOF_VOID_P}" EQUAL 4)
      set(TIFF_SSIZE_T   "signed __int32")
      set(TIFF_SSIZE_FORMAT "%d")
      set(TIFF_SIZE_FORMAT "%u")
    else()
      message(FATAL_ERROR "unknown ssize_t")
    endif()
  else()
    set(TIFF_SSIZE_T   ssize_t)
  endif()
  set(TIFF_INT32_FORMAT "%d")
  set(TIFF_UINT32_FORMAT "%u")
  set(TIFF_INT64_FORMAT "%lld")
  set(TIFF_UINT64_FORMAT "%llu")
  set(TIFF_PTRDIFF_FORMAT "%ld")
endif()

#
set(VERSION "\"4.0.6\"")
set(PACKAGE_VERSION ${VERSION})
set(PACKAGE "\"tiff\"")

# universal build ?
if(APPLE)
  set(AC_APPLE_UNIVERSAL_BUILD 1)
endif()
if(UNIX)
  set(CMAKE_REQUIRED_LIBRARIES m)
  set(HAVE_LIBM 1)
endif()
CHECK_SYMBOL_EXISTS(floor "math.h" HAVE_FLOOR)
CHECK_SYMBOL_EXISTS(sqrt "math.h" HAVE_SQRT)
CHECK_SYMBOL_EXISTS(pow "math.h" HAVE_POW)
CHECK_SYMBOL_EXISTS(lfind "search.h" HAVE_LFIND)
CHECK_SYMBOL_EXISTS(setmod "io.h" HAVE_SETMODE)

# http://www.cmake.org/pipermail/cmake/2007-September/016285.html
foreach(KEYWORD "inline" "__inline__" "__inline")
  if(NOT DEFINED C_INLINE)
    try_compile(C_HAS_${KEYWORD} "${CMAKE_CURRENT_BINARY_DIR}"
       "${CMAKE_CURRENT_SOURCE_DIR}/test_inline.c"
       COMPILE_DEFINITIONS "-Dinline=${KEYWORD}")
    if(C_HAS_${KEYWORD})
      set(C_INLINE TRUE)
      set(INLINE_KEYWORD "${KEYWORD}")
    endif(C_HAS_${KEYWORD})
  endif(NOT DEFINED C_INLINE)
endforeach(KEYWORD)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/tiffconf.h.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/tiffconf.h @ONLY)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/tif_config.h.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/tif_config.h @ONLY)

set(LIBTARGET "tiff")
#
add_library(${LIBTARGET} STATIC ${TARGET_FILES})
#
set_target_properties(${LIBTARGET}
  PROPERTIES
  OUTPUT_NAME "${LIBTARGET}"
  ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/thirdparty/lib
)

=== thirdparty/libz/CMakeLists.txt ===
#based on zlib-1.2.5/CMakeLists.txt
#
cmake_minimum_required(VERSION 2.6)
set(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS ON)

project(zlib C)

include(CheckTypeSize)
include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckCSourceCompiles)

CHECK_INCLUDE_FILE(sys/types.h HAVE_SYS_TYPES_H)
CHECK_INCLUDE_FILE(stdint.h    HAVE_STDINT_H)
CHECK_INCLUDE_FILE(stddef.h    HAVE_STDDEF_H)

#
# Check to see if we have large file support
#
set(CMAKE_REQUIRED_DEFINITIONS -D_LARGEFILE64_SOURCE=1)
# We add these other definitions here because CheckTypeSize.cmake
# in CMake 2.4.x does not automatically do so and we want
# compatibility with CMake 2.4.x.
if(HAVE_SYS_TYPES_H)
    list(APPEND CMAKE_REQUIRED_DEFINITIONS -DHAVE_SYS_TYPES_H)
endif()
if(HAVE_STDINT_H)
    list(APPEND CMAKE_REQUIRED_DEFINITIONS -DHAVE_STDINT_H)
endif()
if(HAVE_STDDEF_H)
    list(APPEND CMAKE_REQUIRED_DEFINITIONS -DHAVE_STDDEF_H)
endif()
CHECK_TYPE_SIZE(off64_t OFF64_T)
if(HAVE_OFF64_T)
   add_definitions(-D_LARGEFILE64_SOURCE=1)
endif()
set(CMAKE_REQUIRED_DEFINITIONS) # clear variable
#
# Check for fseeko
#
CHECK_FUNCTION_EXISTS(fseeko HAVE_FSEEKO)
if(NOT HAVE_FSEEKO)
    add_definitions(-DNO_FSEEKO)
endif()
#
# Check for unistd.h
#
CHECK_INCLUDE_FILE(unistd.h Z_HAVE_UNISTD_H)

include_directories(
 ${CMAKE_CURRENT_SOURCE_DIR}
 ${OPENJPEG_SOURCE_DIR}/thirdparty/include
)
#
set(EXT_HDRS
 ${OPENJPEG_SOURCE_DIR}/thirdparty/include/zlib.h
 ${OPENJPEG_SOURCE_DIR}/thirdparty/include/zconf.h
)

set(HDRS
    crc32.h
    deflate.h
    gzguts.h
    inffast.h
    inffixed.h
    inflate.h
    inftrees.h
    trees.h
    zutil.h
)
set(SRCS
    adler32.c
    compress.c
    crc32.c
    deflate.c
    gzclose.c
    gzlib.c
    gzread.c
    gzwrite.c
    inflate.c
    infback.c
    inftrees.c
    inffast.c
    trees.c
    uncompr.c
    zutil.c
)

set(LIBTARGET "z")
#
add_library(${LIBTARGET} STATIC ${SRCS} ${EXT_HDRS} ${HDRS})
#
if(MSVC)
  set_target_properties(${LIBTARGET} PROPERTIES PREFIX "lib")
endif(MSVC)

set_target_properties(${LIBTARGET}
    PROPERTIES
    OUTPUT_NAME "${LIBTARGET}"
    ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/thirdparty/lib
)
#

=== src/bin/jpip/CMakeLists.txt ===
# Headers file are located here:
include_directories(
  ${OPENJPEG_BINARY_DIR}/src/lib/openjp2 # opj_config.h
  ${OPENJPEG_SOURCE_DIR}/src/lib/openjp2
  ${OPENJPEG_SOURCE_DIR}/src/bin/common # opj_getopt.h
  ${OPENJPEG_SOURCE_DIR}/src/bin/jp2 # convert.h
  ${OPENJPEG_SOURCE_DIR}/src/lib/openjpip
  ${FCGI_INCLUDE_DIRS}
)

# Tool to embed metadata into JP2 file
add_executable(opj_jpip_addxml opj_jpip_addxml.c)
# Install exe
install(TARGETS opj_jpip_addxml
  EXPORT OpenJPEGTargets
  DESTINATION ${OPENJPEG_INSTALL_BIN_DIR} COMPONENT Applications
  )

if(BUILD_JPIP_SERVER)
  set(OPJ_SERVER_SRCS
  ${CMAKE_CURRENT_SOURCE_DIR}/opj_server.c
  )

  # Build executable
  add_executable(opj_server ${OPJ_SERVER_SRCS})
  target_link_libraries(opj_server ${FCGI_LIBRARIES} openjpip_server)
  set_property(
    TARGET opj_server
    APPEND PROPERTY
    COMPILE_DEFINITIONS SERVER QUIT_SIGNAL="quitJPIP"
    )

  # On unix you need to link to the math library:
  if(UNIX)
    target_link_libraries(opj_server m)
  endif()

  # Install exe
  install(TARGETS opj_server
    EXPORT OpenJPEGTargets
    DESTINATION ${OPENJPEG_INSTALL_BIN_DIR} COMPONENT Applications
    )
endif()

set(EXES
  opj_dec_server
  opj_jpip_transcode
  opj_jpip_test
  )
foreach(exe ${EXES})
add_executable(${exe} ${exe}.c)
  target_link_libraries(${exe} openjpip)
  install(TARGETS ${exe}
    EXPORT OpenJPEGTargets
    DESTINATION ${OPENJPEG_INSTALL_BIN_DIR} COMPONENT Applications
    )
endforeach()

# Build the two java clients:
find_package(Java 1.5 COMPONENTS Development) # javac, jar

# User can override this:
if(NOT DEFINED JAVA_SOURCE_VERSION)
  set(JAVA_SOURCE_VERSION 1.5)
endif()
if(NOT DEFINED JAVA_TARGET_VERSION)
  set(JAVA_TARGET_VERSION 1.5)
endif()

# Only build the java viewer if dev is found:
if(Java_Development_FOUND AND Java_JAVAC_EXECUTABLE)
  set(jflags $ENV{JFLAGS})
  # search for package org.apache.xerces.parsers
  find_file(APACHE_XERCES_JAR
    NAMES xerces-j2.jar xercesImpl.jar
    PATHS /usr/share/java/
    NO_DEFAULT_PATH
    )
  mark_as_advanced(APACHE_XERCES_JAR)

  # Decide to build the simple viewer or the xerces one:
  if(EXISTS ${APACHE_XERCES_JAR})
    configure_file(
      ${CMAKE_CURRENT_SOURCE_DIR}/opj_viewer_xerces/dist/manifest.txt.in
      ${CMAKE_CURRENT_BINARY_DIR}/opj_viewer_xerces/dist/manifest.txt
      @ONLY
      )
    # build dep list:
    file(GLOB java2_srcs "opj_viewer_xerces/src/*.java")

    # Need some common files:
    list(APPEND java2_srcs
      ${CMAKE_CURRENT_SOURCE_DIR}/opj_viewer/src/ImageManager.java
      ${CMAKE_CURRENT_SOURCE_DIR}/opj_viewer/src/ImgdecClient.java
      ${CMAKE_CURRENT_SOURCE_DIR}/opj_viewer/src/JPIPHttpClient.java
      ${CMAKE_CURRENT_SOURCE_DIR}/opj_viewer/src/MML.java
      ${CMAKE_CURRENT_SOURCE_DIR}/opj_viewer/src/PnmImage.java
      ${CMAKE_CURRENT_SOURCE_DIR}/opj_viewer/src/RegimViewer.java
      ${CMAKE_CURRENT_SOURCE_DIR}/opj_viewer/src/ResizeListener.java
      )

    # make sure target javac dir exists:
    file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/classes2)
    # Build java
    add_custom_command(
      OUTPUT ${LIBRARY_OUTPUT_PATH}/opj_jpip_viewer.jar
      COMMAND ${Java_JAVAC_EXECUTABLE} ${jflags}
      -source ${JAVA_SOURCE_VERSION} -target ${JAVA_TARGET_VERSION}
      -classpath ${APACHE_XERCES_JAR}
      ${java2_srcs} -d ${CMAKE_CURRENT_BINARY_DIR}/classes2
      COMMAND ${Java_JAR_EXECUTABLE} cfm ${LIBRARY_OUTPUT_PATH}/opj_jpip_viewer.jar
      ${CMAKE_CURRENT_BINARY_DIR}/opj_viewer_xerces/dist/manifest.txt
      -C ${CMAKE_CURRENT_BINARY_DIR}/classes2 .
      DEPENDS ${java2_srcs}
      ${CMAKE_CURRENT_SOURCE_DIR}/opj_viewer_xerces/dist/manifest.txt.in
      COMMENT "javac *.java; jar cvf -> opj_viewer_xerces.jar"
      )

    # name the target
    add_custom_target(OPJViewerXercesJar ALL
      DEPENDS ${LIBRARY_OUTPUT_PATH}/opj_jpip_viewer.jar
      COMMENT "building opj_jpip_viewer.jar (xerces)"
      )

    install(FILES ${LIBRARY_OUTPUT_PATH}/opj_jpip_viewer.jar
      DESTINATION ${OPENJPEG_INSTALL_SHARE_DIR} COMPONENT JavaModule
      )
  else()
    # opj_viewer (simple, no xerces)
    # build dep list:
    file(GLOB java1_srcs "opj_viewer/src/*.java")

    # make sure target javac dir exists:
    file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/classes1)
    # Build java
    add_custom_command(
      OUTPUT ${LIBRARY_OUTPUT_PATH}/opj_jpip_viewer.jar
      COMMAND ${Java_JAVAC_EXECUTABLE} ${jflags}
      -source ${JAVA_SOURCE_VERSION} -target ${JAVA_TARGET_VERSION}
      ${java1_srcs} -d ${CMAKE_CURRENT_BINARY_DIR}/classes1
      COMMAND ${Java_JAR_EXECUTABLE} cfm ${LIBRARY_OUTPUT_PATH}/opj_jpip_viewer.jar
      ${CMAKE_CURRENT_SOURCE_DIR}/opj_viewer/dist/manifest.txt -C
      ${CMAKE_CURRENT_BINARY_DIR}/classes1 .
      DEPENDS ${java1_srcs}
      ${CMAKE_CURRENT_SOURCE_DIR}/opj_viewer/dist/manifest.txt
      COMMENT "javac *.java; jar cvf -> opj_jpip_viewer.jar"
      )

    # name the target
    add_custom_target(OPJViewerJar ALL
      DEPENDS ${LIBRARY_OUTPUT_PATH}/opj_jpip_viewer.jar
      COMMENT "building opj_jpip_viewer.jar (no xerces found)"
      )

    install(FILES ${LIBRARY_OUTPUT_PATH}/opj_jpip_viewer.jar
      DESTINATION ${OPENJPEG_INSTALL_SHARE_DIR} COMPONENT JavaModule
      )
  endif()
else()
  message(WARNING "No java compiler found. Wont be able to build java viewer")
endif()

=== src/lib/openjpip/CMakeLists.txt ===
include_regular_expression("^.*$")

add_definitions(-DUSE_JPIP)

include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${OPENJPEG_BINARY_DIR}/src/lib/openjp2 # opj_config.h
  ${OPENJPEG_SOURCE_DIR}/src/lib/openjp2
  ${FCGI_INCLUDE_DIRS}
  ${CURL_INCLUDE_DIRS}
)

# Defines the source code for the library
set(OPENJPIP_SRCS
  ${CMAKE_CURRENT_SOURCE_DIR}/boxheader_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/codestream_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/imgreg_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/marker_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/msgqueue_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/box_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/faixbox_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/index_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/metadata_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/placeholder_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/byte_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/ihdrbox_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/manfbox_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/mhixbox_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/target_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/cachemodel_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/j2kheader_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/jp2k_encoder.c
  ${CMAKE_CURRENT_SOURCE_DIR}/openjpip.c
  ${CMAKE_CURRENT_SOURCE_DIR}/query_parser.c
  ${CMAKE_CURRENT_SOURCE_DIR}/channel_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/session_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/jpip_parser.c
  ${CMAKE_CURRENT_SOURCE_DIR}/sock_manager.c
  ${OPENJPEG_SOURCE_DIR}/src/lib/openjp2/opj_malloc.c
  )

set(SERVER_SRCS
  ${CMAKE_CURRENT_SOURCE_DIR}/auxtrans_manager.c
  )

set(LOCAL_SRCS
  ${CMAKE_CURRENT_SOURCE_DIR}/jp2k_decoder.c
  ${CMAKE_CURRENT_SOURCE_DIR}/imgsock_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/jpipstream_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/cache_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/dec_clientmsg_handler.c
  )

# Build the library
if(WIN32)
  if(BUILD_SHARED_LIBS)
    add_definitions(-DOPJ_EXPORTS)
  else()
    add_definitions(-DOPJ_STATIC)
  endif()
endif()
add_library(openjpip ${OPENJPIP_SRCS} ${LOCAL_SRCS})
set_target_properties(openjpip
  PROPERTIES ${OPENJPEG_LIBRARY_PROPERTIES})
if(NOT ${CMAKE_VERSION} VERSION_LESS "2.8.12")
  target_compile_options(openjpip PRIVATE ${OPENJPEG_LIBRARY_COMPILE_OPTIONS})
endif()
target_link_libraries(openjpip ${OPENJPEG_LIBRARY_NAME})
if(WIN32)
  # add Winsock on windows+mingw
  target_link_libraries(openjpip ws2_32)
endif()

# Install library
install(TARGETS openjpip
  EXPORT OpenJPEGTargets
  RUNTIME DESTINATION ${OPENJPEG_INSTALL_BIN_DIR} COMPONENT Applications
  LIBRARY DESTINATION ${OPENJPEG_INSTALL_LIB_DIR} COMPONENT Libraries
  ARCHIVE DESTINATION ${OPENJPEG_INSTALL_LIB_DIR} COMPONENT Libraries
  )

if(BUILD_JPIP_SERVER)
  add_library(openjpip_server STATIC ${OPENJPIP_SRCS} ${SERVER_SRCS})
  target_link_libraries(openjpip_server ${FCGI_LIBRARIES} ${CURL_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
  set_target_properties(openjpip_server
    PROPERTIES COMPILE_FLAGS "-DSERVER")
  install(TARGETS openjpip_server
    EXPORT OpenJPEGTargets
    DESTINATION ${OPENJPEG_INSTALL_LIB_DIR} COMPONENT Libraries
    )
endif()

=== wrapping/java/openjp2/CMakeLists.txt ===
#JavaOpenJPEG/CMakeLists.txt

# First thing define the common source:
set(openjpegjni_SRCS
  JavaOpenJPEGDecoder.c
  JavaOpenJPEG.c
  ${OPENJPEG_SOURCE_DIR}/src/bin/common/opj_getopt.c
  ${OPENJPEG_SOURCE_DIR}/src/bin/jp2/convert.c
  index.c
  )

# JNI binding:
find_package(JNI REQUIRED)
include_directories(${JNI_INCLUDE_DIRS})

# required header file:
include_directories(
  ${OPENJPEG_BINARY_DIR}/src/lib/openjp2 # opj_config.h
  ${OPENJPEG_SOURCE_DIR}/src/lib/openmj2
  ${OPENJPEG_SOURCE_DIR}/src/bin/common
  ${OPENJPEG_SOURCE_DIR}/src/bin/jp2
  )

add_library(openjpegjni MODULE
  ${openjpegjni_SRCS}
  )
# Java module should not have a SONAME:
set_property(TARGET openjpegjni PROPERTY NO_SONAME 1)

# FIXME (need to use old API):
if(BUILD_MJ2)
  target_link_libraries(openjpegjni openmj2)
endif()
target_link_libraries(openjpegjni
  ${PNG_LIBNAME} ${TIFF_LIBNAME} ${LCMS_LIBNAME} ${Z_LIBNAME}
)
if(UNIX)
  target_link_libraries(openjpegjni m)
endif()

install(TARGETS openjpegjni
  EXPORT OpenJPEGTargets
  LIBRARY DESTINATION ${OPENJPEG_INSTALL_JNI_DIR} COMPONENT Libraries
)

# build jar:
find_package(Java 1.5 REQUIRED) # javac, jar

# build dep list:
file(GLOB java_srcs "java-sources/org/openJpeg/*.java")

# make sure target javac dir exists:
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/classes)
# Build java
add_custom_command(
  OUTPUT ${LIBRARY_OUTPUT_PATH}/openjpeg.jar
  COMMAND ${Java_JAVAC_EXECUTABLE} -sourcepath  "${CMAKE_CURRENT_SOURCE_DIR}/java-sources"
  ${java_srcs} -d ${CMAKE_CURRENT_BINARY_DIR}/classes
  COMMAND ${Java_JAR_EXECUTABLE} cvf ${LIBRARY_OUTPUT_PATH}/openjpeg.jar org
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/classes
  DEPENDS ${java_srcs}
  COMMENT "javac *.java; jar cvf -> openjpeg.jar"
)

# name the target
add_custom_target(OpenJPEGJavaJar ALL
  DEPENDS ${LIBRARY_OUTPUT_PATH}/openjpeg.jar
  COMMENT "building openjpeg.jar"
)

install(FILES ${LIBRARY_OUTPUT_PATH}/openjpeg.jar
  DESTINATION ${OPENJPEG_INSTALL_SHARE_DIR} COMPONENT JavaModule
)

=== debian/changelog ===
openjpeg2 (2.3.1-1ubuntu4.20.04.4) focal-security; urgency=medium

  * SECURITY UPDATE: Heap buffer overflow.
    - debian/patches/CVE-2024-56826.patch: Add comp12w variable and
      comparisons in src/bin/common/color.c.
    - debian/patches/CVE-2024-56827.patch: Add l_current_tile_part comparison
      to check again total number of tile parts in src/bin/openjp2/j2k.c.
    - CVE-2024-56826
    - CVE-2024-56827

 -- Hlib Korzhynskyy <hlib.korzhynskyy@canonical.com>  Tue, 21 Jan 2025 12:27:28 -0330

openjpeg2 (2.3.1-1ubuntu4.20.04.3) focal-security; urgency=medium

  * SECURITY UPDATE: integer overflow
    - debian/patches/CVE-2021-29338-1.patch:
    opj_compress/opj_uncompress: fix integer overflow in num_images
    - debian/patches/CVE-2021-29338-2.patch: Avoid overflow in
      multiplications in utilities related to big number of files in a
      directory
    - CVE-2021-29338
  * SECURITY UPDATE: heap buffer overflow
    - debian/patches/CVE-2021-3575.patch: opj_decompress: fix off-by-one
      read heap-buffer-overflow in sycc420_to_rgb() when x0 and y0 are odd
    - CVE-2021-3575
  * SECURITY UPDATE: denial of service
    - debian/patches/CVE-2022-1122.patch: Fix segfault in
      src/bin/jp2/opj_decompress.c due to uninitialized pointer
    - CVE-2022-1122

 -- Bruce Cable <bruce.cable@canonical.com>  Tue, 22 Oct 2024 16:03:30 +1100

openjpeg2 (2.3.1-1ubuntu4.20.04.2) focal-security; urgency=medium

  * SECURITY UPDATE: resource consumption loop
    - debian/patches/CVE-2023-39327.patch: when EPH markers are specified, 
      they are required
    - CVE-2023-39327

 -- Bruce Cable <bruce.cable@canonical.com>  Wed, 25 Sep 2024 12:59:17 +1000

openjpeg2 (2.3.1-1ubuntu4.20.04.1) focal-security; urgency=medium

  * SECURITY UPDATE: use-after-free via directory
    - debian/patches/CVE-2020-15389.patch: fix double-free on input
      directory with mix of valid and invalid images in
      src/bin/jp2/opj_decompress.c.
    - CVE-2020-15389
  * SECURITY UPDATE: heap-buffer-overflow
    - debian/patches/CVE-2020-27814-1.patch: grow buffer size in
      src/lib/openjp2/tcd.c.
    - debian/patches/CVE-2020-27814-2.patch: grow it again
    - debian/patches/CVE-2020-27814-3.patch: and some more
    - debian/patches/CVE-2020-27814-4.patch: bigger, BIGGER!!!
    - CVE-2020-27814
  * SECURITY UPDATE: heap-buffer-overflow write
    - debian/patches/CVE-2020-27823.patch: fix wrong computation in
      src/bin/jp2/convertpng.c.
    - CVE-2020-27823
  * SECURITY UPDATE: global-buffer-overflow
    - debian/patches/CVE-2020-27824.patch: avoid global buffer overflow on
      irreversible conversion when too many decomposition levels are
      specified in src/lib/openjp2/dwt.c.
    - CVE-2020-27824
  * SECURITY UPDATE: out-of-bounds read
    - debian/patches/CVE-2020-27841.patch: add extra checks to
      src/lib/openjp2/pi.c, src/lib/openjp2/pi.h, src/lib/openjp2/t2.c.
    - CVE-2020-27841
  * SECURITY UPDATE: null pointer dereference
    - debian/patches/CVE-2020-27842.patch: add check to
      src/lib/openjp2/t2.c.
    - CVE-2020-27842
  * SECURITY UPDATE: out-of-bounds read
    - debian/patches/CVE-2020-27843.patch: add check to
      src/lib/openjp2/t2.c.
    - CVE-2020-27843
  * SECURITY UPDATE: out-of-bounds read
    - debian/patches/CVE-2020-27845.patch: add extra checks to
      src/lib/openjp2/pi.c.
    - CVE-2020-27845

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 06 Jan 2021 09:44:46 -0500

openjpeg2 (2.3.1-1ubuntu4) focal; urgency=medium

  * SECURITY UPDATE: denial of service via excessive iteration
    - debian/patches/CVE-2019-12973-1.patch: detect invalid file dimensions
      early in src/bin/jp2/convertbmp.c.
    - debian/patches/CVE-2019-12973-2.patch: avoid potential infinite loop
      in src/bin/jp2/convertbmp.c.
    - CVE-2019-12973
  * SECURITY UPDATE: heap overflow in opj_t1_clbl_decode_processor
    - debian/patches/CVE-2020-6851.patch: reject images whose
      coordinates are beyond INT_MAX in src/lib/openjp2/j2k.c.
    - CVE-2020-6851
  * SECURITY UPDATE: another heap overflow in opj_t1_clbl_decode_processor
    - debian/patches/CVE-2020-8112.patch: avoid integer overflow in
      src/lib/openjp2/tcd.c.
    - CVE-2020-8112

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 19 Feb 2020 09:52:00 -0500

openjpeg2 (2.3.1-1ubuntu3) focal; urgency=medium

  * Actually omit libopenjpip-server, not libkate-tools which is not in
    this package.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 17 Feb 2020 09:39:20 -0800

openjpeg2 (2.3.1-1ubuntu2) focal; urgency=medium

  * No-change rebuild with fixed binutils on arm64.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 10 Feb 2020 08:14:07 +0100

openjpeg2 (2.3.1-1ubuntu1) focal; urgency=medium

  * Omit libopenjpip-server on i386, we only want the libraries for
    compatibility.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 07 Jan 2020 14:52:51 -0800

openjpeg2 (2.3.1-1) unstable; urgency=medium

  * New upstream release, addressing following security issues:
    - CVE-2018-20847 (Closes: #931294)
    - CVE-2018-21010 (Closes: #939553)
    - CVE-2018-5727 (Closes: #888532)
  * Remove following patches, applied upstream:
    - CVE-2017-17480.patch
    - CVE-2018-14423.patch
    - CVE-2018-18088.patch
    - CVE-2018-5785.patch
    - CVE-2018-6616.patch
  * Remove debian/patches/multiarch_path.patch:
    - useless since latest upstream changes.
  * Bump Standards-Version to 4.4.1.
  * Refresh and rework manpages.
  * Remove debian/README.source (Closes: #846390).

 -- Hugo Lefeuvre <hle@debian.org>  Mon, 07 Oct 2019 13:46:43 +0200

openjpeg2 (2.3.0-3) unstable; urgency=medium

  [ Helmut Grohne ]
  * Demote java dependencies to Build-Depends-Indep. (Closes: #870644)

  [ Mathieu Malaterre ]
  * debian/control: update URLs to new salsa location

 -- Mathieu Malaterre <malat@debian.org>  Mon, 30 Sep 2019 15:17:58 +0200

=== debian/control ===
Source: openjpeg2
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
Uploaders: Mathieu Malaterre <malat@debian.org>, Hugo Lefeuvre <hle@debian.org>
Homepage: http://www.openjpeg.org
Build-Depends: cmake (>= 2.8.2),
               debhelper (>= 9),
               dh-apache2,
               help2man,
               libcurl4-gnutls-dev | libcurl-ssl-dev,
               libfcgi-dev,
               liblcms2-dev,
               libpng-dev,
               libtiff-dev,
               zlib1g-dev
Build-Depends-Indep:
               default-jdk,
               javahelper (>= 0.37~),
               libxerces2-java,
Standards-Version: 4.4.1
Section: libs
Vcs-Browser: https://salsa.debian.org/debian-phototools-team/openjpeg2
Vcs-Git: https://salsa.debian.org/debian-phototools-team/openjpeg2.git

Package: libopenjp2-7-dev
Section: libdevel
Architecture: any
Depends: libopenjp2-7 (= ${binary:Version}), ${misc:Depends}
Description: development files for OpenJPEG, a JPEG 2000 image library
 OpenJPEG is a library for handling the JPEG 2000 image compression format.
 JPEG 2000 is a wavelet-based image compression standard and permits progressive
 transmission by pixel and resolution accuracy for progressive downloads of an
 encoded image. It supports lossless and lossy compression, supports higher
 compression than JPEG 1991, and has resilience to errors in the image.
 .
 This package contains the development files for openjpeg 2.x

Package: libopenjp2-7
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: JPEG 2000 image compression/decompression library
 OpenJPEG is a library for handling the JPEG 2000 image compression format.
 JPEG 2000 is a wavelet-based image compression standard and permits progressive
 transmission by pixel and resolution accuracy for progressive downloads of an
 encoded image. It supports lossless and lossy compression, supports higher
 compression than JPEG 1991, and has resilience to errors in the image.
 .
 This package contains the runtime files for openjpeg 2.x

Package: libopenjpip7
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: JPEG 2000 Interactive Protocol
 OpenJPEG is a library for handling the JPEG 2000 image compression format.
 JPEG 2000 is a wavelet-based image compression standard and permits progressive
 transmission by pixel and resolution accuracy for progressive downloads of an
 encoded image. It supports lossless and lossy compression, supports higher
 compression than JPEG 1991, and has resilience to errors in the image.
 .
 This is an implementation of the JPEG 2000 Interactive Protocol (Part-9)

Package: libopenjp3d7
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: JP3D (JPEG 2000 / Part 10) image compression/decompression library
 OpenJPEG is a library for handling the JPEG 2000 image compression format.
 JPEG 2000 is a wavelet-based image compression standard and permits progressive
 transmission by pixel and resolution accuracy for progressive downloads of an
 encoded image. It supports lossless and lossy compression, supports higher
 compression than JPEG 1991, and has resilience to errors in the image.
 .
 This is an implementation of the JPEG 2000 (JP3D) volumetric imaging (Part-10)

Package: libopenjpip-dec-server
Section: graphics
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: openjpip-dec-server
Description: tool to allow caching of JPEG 2000 files using JPIP protocol
 This is client side application for caching remote JPEG 2000 using the JPIP
 protocol. This command line application needs to run on the client side to
 allow application such as opj_viewer to view images.

Package: libopenjpip-viewer
Section: graphics
Architecture: all
Depends: libopenjpip-dec-server, ${java:Depends}, ${misc:Depends}
Suggests: libopenjp2-tools
Conflicts: openjpip-viewer
Description: JPEG 2000 java based viewer for advanced remote JPIP access
 Java based client to view remote JPEG 2000 using JPIP protocol.
 This is a simple java viewer to allow:
 .
  - Scale up request: Enlarge the window
  - ROI request: Select a region by mouse click and drag, then click inside the
    red frame of the selected region
  - Annotate image with ROI information in XML metadata: Click button "Region
    Of Interest"
  - Open a new window presenting an aligned image with a locally stored image:
    Click button "Image Registration" (Under Construction)

Package: libopenjpip-server
Section: graphics
Architecture: any
Multi-Arch: foreign
Depends: libwww-perl,
         spawn-fcgi (>= 1.6.1),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: ${misc:Recommends}
Conflicts: openjpip-server
Description: JPIP server for JPEG 2000 files
 OpenJPIP software is an implementation of JPEG 2000 Part9: Interactivity tools,
 APIs and protocols (JPIP). For more info about JPIP, check the website:
 http://www.jpeg.org/jpeg2000/j2kpart9.html. The current implementation uses
 some results from the 2KAN project (http://www.2kan.org).
 .
 First Version covers:
 .
  - JPT-stream (Tile based) and JPP-stream (Precinct based) media types
  - Session, channels, cache model managements
  - JPIP over HTTP
  - Indexing JPEG 2000 files
  - Embedding XML formatted metadata
  - Region Of Interest (ROI) requests

Package: libopenjp3d-tools
Section: graphics
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: libopenjp2-tools
Description: command-line tools using the JPEG 2000 - 3D library
 This package provides with command-line tools allowing for conversions between
 several formats and also provides tools for encoding and decoding
 jpeg 3D formats:
 .
  - opj_jp3d_compress: compress into JP3D volume
  - opj_jp3d_decompress: decompress JP3D volume

Package: libopenjp2-tools
Section: graphics
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: command-line tools using the JPEG 2000 library
 This package provides with command-line tools allowing for conversions between
 several formats and also provides tools for encoding and decoding
 motion-jpeg2000 video formats:
 .
  - opj_decompress: decodes j2k, jp2, and jpt files to pgm, ppm, pnm,
                  pgx, and bmp.
  - opj_compress: encodes pnm, pgm, pgx, bmp, and ppm files to j2k,
                  and jp2.
  - opj_dump: dump information contains in j2k and jp2.
  - index_create: create jp2 with JPIP index file from a j2k file.
  - frames_to_mj2: convert YUV video streams to mj2 format.
  - mj2_to_frames: convert mj2 video streams to YUV format.
  - wrap_j2k_in_mj2: wrap j2k codestreams into mj2 format.
  - extract-j2k-from_mj2: extract j2k codestreams from the mj2 format.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# as per upstream request:
export DEB_CFLAGS_MAINT_APPEND = -fvisibility=hidden

ifeq ($(shell dpkg-vendor --is Ubuntu && echo yes) $(DEB_HOST_ARCH), yes i386)
   BUILD_PACKAGES += -Nlibopenjpip-server
endif

%:
	dh $@ --parallel --with apache2 $(DH_ADDONS) $(BUILD_PACKAGES)
build binary %-indep: DH_ADDONS=--with=javahelper

CMAKE_EXTRA_FLAGS += -DCMAKE_SKIP_RPATH=ON \
  -DCMAKE_BUILD_TYPE:STRING=None \
  -DOPENJPEG_INSTALL_LIB_DIR:STRING=lib/$(DEB_HOST_MULTIARCH) \
  -DBUILD_CODEC:BOOL=ON \
  -DBUILD_JPIP:BOOL=ON \
  -DBUILD_JPIP_SERVER:BOOL=ON \
  -DBUILD_JPWL:BOOL=OFF \
  -DBUILD_JAVA:BOOL=OFF \
  -DBUILD_MJ2:BOOL=OFF \
  -DBUILD_JP3D:BOOL=ON \
  -DBUILD_SHARED_LIBS:BOOL=ON \
  -DBUILD_TESTING:BOOL=OFF \
  -DBUILD_DOC:BOOL=ON \
  -DBUILD_THIRDPARTY:BOOL=OFF

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

SOVERSION=7
pkg_lib = libopenjp2-$(SOVERSION)
pkg_dev = libopenjp2-$(SOVERSION)-dev
pkg_bin = libopenjp2-tools
pkg_lib3d = libopenjp3d$(SOVERSION)
pkg_bin3d = libopenjp3d-tools
pkg_jpip = libopenjpip$(SOVERSION)
pkg_srv = libopenjpip-server
pkg_vwr = libopenjpip-viewer
pkg_dsrv = libopenjpip-dec-server

override_dh_install:
	# annoying cmake-fatal-error export stuff:
	sed -i -e "s/FATAL_ERROR/STATUS/g" debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/openjpeg-2.3/OpenJPEGTargets*.cmake
	# install opj_dump/compress/decompress:
	dh_install -p$(pkg_bin) --autodest -Xjp3d -Xserver -Xjpip usr/bin/*
	dh_install -p$(pkg_bin) --autodest -Xserver -Xjpip usr/share/man/man1/*.1
	# lib
	dh_install -p$(pkg_lib) --autodest usr/lib/$(DEB_HOST_MULTIARCH)/libopenjp2.so.*
	# dev:
	dh_install -p$(pkg_dev) --autodest usr/lib/$(DEB_HOST_MULTIARCH)/libopenjp2.so
	dh_install -p$(pkg_dev) --autodest usr/lib/$(DEB_HOST_MULTIARCH)/openjpeg-2.3/*.cmake
	dh_install -p$(pkg_dev) --autodest usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/*.pc
	dh_install -p$(pkg_dev) --autodest usr/include/openjpeg-2.3
	# accept hardcoded path to 2.1 (2.3 kept the same SONAME):
	dh_link -p$(pkg_dev) usr/lib/$(DEB_HOST_MULTIARCH)/openjpeg-2.3 usr/lib/$(DEB_HOST_MULTIARCH)/openjpeg-2.1
	dh_link -p$(pkg_dev) usr/include/openjpeg-2.3 usr/include/openjpeg-2.1
	# jp3d:
	dh_install -p$(pkg_lib3d) --autodest usr/lib/$(DEB_HOST_MULTIARCH)/libopenjp3d.so.*
	dh_install -p$(pkg_bin3d) --autodest usr/bin/opj_jp3d*
	# libjpip:
	dh_install -p$(pkg_jpip) --autodest usr/lib/$(DEB_HOST_MULTIARCH)/libopenjpip.so.*
	# server:
	dh_install -p$(pkg_srv) --autodest usr/bin/opj_server
	# dec-server
	dh_install -p$(pkg_dsrv) --autodest usr/bin/opj_dec_server
	dh_install -p$(pkg_dsrv) --autodest usr/bin/opj_jpip*
	dh_install --list-missing

CURVER := $(shell dpkg-parsechangelog | grep ^Version | awk '{print $$2}' | cut -d- -f1 | cut -d+ -f1)

get-orig-source:
	uscan --verbose --rename \
    --force-download \
    --download-version $(CURVER)

# create man pages:
export LD_LIBRARY_PATH := $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/:$(LD_LIBRARY_PATH)
export PATH := $(CURDIR)/debian/tmp/usr/bin:$(PATH)

VER_FULL = $(shell dpkg-parsechangelog -Sversion | cut -d - -f 1)

debian/%.1: debian/opj_common.1.in
	help2man --include=$< --output=$@ --name="Works with JPEG2000 files" \
		--no-info --no-discard-stderr `basename $@ .1` --help-option=-h --version-string=$(VER_FULL)

opj_manpages: debian/opj_jp3d_decompress.1 debian/opj_jp3d_compress.1 debian/opj_jpip_addxml.1 debian/opj_jpip_test.1 debian/opj_jpip_transcode.1
	echo "all missing man pages done"

# never returns:
# debian/opj_dec_server.1 debian/opj_server.1 debian/opj_jpip_viewer.1

override_dh_installman: opj_manpages
	dh_installman -p$(pkg_lib3d) debian/opj_jp3d_*.1
	dh_installman -p$(pkg_dsrv) debian/opj_jpip_*.1
	#dh_installman -p$(pkg_srv) debian/opj_server.1
	#dh_installman -p$(pkg_vwr) debian/opj_dec_server.1
	#dh_installman

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/openjpeg-$1\.tar\.gz/ \
  https://github.com/uclouvain/openjpeg/tags .*/v?(\d\S*)\.tar\.gz
